const lo = require('lodash');
const hlp = require('../../../../helpers')

const sections = ['BLPolicy']
const formValues = ['UseAutoScalability',
                    'ScalabilityProcessCount',
                    'ScalabilityProcessCountUsedByRtp',
                    'ScalabilityLowPriorityProcessCount'
]

function toView (policiesCache) {
    let computedData = {}
    computedData.Scalability = hlp.customToView(policiesCache.BLPolicy.Policy.KLPRSS_Val, formValues)
    computedData.Tray = policiesCache.BLPolicy.Policy.KLPRSS_Val.AutoStartTrayIconApplication
    return computedData
}

function toRaw (changedData, policiesCache) {
    Object.assign( policiesCache.BLPolicy.Policy.KLPRSS_Val, lo.pick(changedData.Scalability, formValues))
    policiesCache.BLPolicy.Policy.KLPRSS_Val.AutoStartTrayIconApplication = changedData.Tray
}

module.exports = {
    sections,
    toView,
    toRaw
};
