const lo = require('lodash');
const hlp = require('../../../../helpers')

const sections = ['TrustedZonePolicy']
const formValues = ['ExclutionRules']

function toView (policiesCache) {
    let data = hlp.customToView(policiesCache.TrustedZonePolicy.Policy.KLPRSS_Val, formValues)
    for(let item of data.ExclutionRules.KLPRSS_Val[0]){
        item.MasksStr = item.ThreatNameMasks.KLPRSS_Val.join(";");
    }
    return data;
}

function toRaw (changedData, policiesCache) {
    var re = new RegExp(/^(\s|\u00A0)+/g);
    let rules = changedData.ExclutionRules.KLPRSS_Val[0]
    for(let item of rules){
        let tmp = item.MasksStr.split(';');
        if(item.ThreatNameMasks===undefined)
            item.ThreatNameMasks = {}
        item.ThreatNameMasks.KLPRSS_Val = tmp.filter(function(x){
            return (x !== (undefined || null || ''));
        });

        delete item.MasksStr
        for(let object of item.Objects.KLPRSS_Val) {
            object.__VersionInfo = {KLPRSS_Mnd:false, KLPRSS_Val:[1,1]}
        }
        item.__VersionInfo = {KLPRSS_Mnd:false, KLPRSS_Val:[1,5]}
    }

    Object.assign( policiesCache.TrustedZonePolicy.Policy.KLPRSS_Val, lo.pick(changedData, formValues))
}

module.exports = {
    sections,
    toView,
    toRaw
};
