const lo = require('lodash');
const hlp = require('../../../../helpers')
const hlpIcap = require('../../../utils/icap.js')
const hlpSch = require('../Schedule/schedule.js')

const sections = ['ICAPScannerPolicy','PredefinedTasksPolicy']
const formCommonValues = ['ServerPort','RespModeUri','UseHeuristicAnalyzer','HeuristicAnalyzerLevel', 'UseKsn','UseSandbox']
const formScopeValues = ['ScanScope']


function toView (policiesCache) {
    let data = {
        Form_Nas_IcapCommon: hlp.customToView(policiesCache.ICAPScannerPolicy.Policy.KLPRSS_Val, formCommonValues),
        Form_Nas_IcapProtLevel: hlp.customToView(policiesCache.ICAPScannerPolicy.Policy.KLPRSS_Val, formScopeValues),
        Form_Policy_IcapSchedule: hlpSch.toView(policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.ICAPSCannerStartOptions)
    }
    // Protection Level
    const scanSetts = policiesCache.ICAPScannerPolicy.Policy.KLPRSS_Val.ScanScope.KLPRSS_Val[0][0].ScanSettings;
    data.Form_Nas_IcapProtLevel.ScanSettings = scanSetts
    data.Form_Nas_IcapProtLevel.uiFields = hlpIcap.getIcapProtLevelUiFields(scanSetts);
    return data
}

function toRaw (changedData, policiesCache) {
    Object.assign(policiesCache.ICAPScannerPolicy.Policy.KLPRSS_Val, lo.pick(changedData.Form_Nas_IcapCommon, formCommonValues))
    // Protection Level
    const scanSett = hlpIcap.IcapScanSettingsFromUiFields(changedData.Form_Nas_IcapProtLevel);
    changedData.Form_Nas_IcapProtLevel.ScanScope.KLPRSS_Val[0][0].ScanSettings = scanSett;
    Object.assign( policiesCache.ICAPScannerPolicy.Policy.KLPRSS_Val, lo.pick(changedData.Form_Nas_IcapProtLevel, formScopeValues))

    // schedule
    hlpSch.toRaw(changedData.Form_Policy_IcapSchedule, policiesCache.PredefinedTasksPolicy.Policy.KLPRSS_Val.ICAPSCannerStartOptions);
}

module.exports = {
    sections,
    toView,
    toRaw
};
