const hlp = require('../../../../helpers');
const utilsEv = require('../../../utils/events.js');

const sections = ['NotificationPolicy'];
const formValues = ['EventsAlertOptions', 'TerminalUsersNotificationTimeout'];

async function toViewEx(kscApi, policiesCache) {
    let data = hlp.customToView(policiesCache.NotificationPolicy.Policy.KLPRSS_Val, formValues);
    // create default alerts list
    if(0===data.EventsAlertOptions.KLPRSS_Val[0].length){
        const loc = await kscApi.utils.getUILanguage();
        data.EventsAlertOptions.KLPRSS_Val[0] = utilsEv.CreateDefaultEvents(loc);
    }

    for(let evt of data.EventsAlertOptions.KLPRSS_Val[0]) {
        evt = utilsEv.AlertToView(evt);
    }
    return data;
}

async function toRawEx (kscApi, changedData, policiesCache) {
    for(let evt of changedData.EventsAlertOptions.KLPRSS_Val[0]) {
        evt = await utilsEv.AlertToRow(kscApi,evt);
        delete evt.uiFields;
    }
    policiesCache.NotificationPolicy.Policy.KLPRSS_Val.EventsAlertOptions = changedData.EventsAlertOptions;
    policiesCache.NotificationPolicy.Policy.KLPRSS_Val.TerminalUsersNotificationTimeout = changedData.TerminalUsersNotificationTimeout;
}

module.exports = {
    sections,
    toViewEx,
    toRawEx
};
