import {ProtectionLevel, ScanTypeEnum, WebActionEnum} from "../types";

function CheckNetAppLevel(data) {
    if ( data.ScanSettings.KLPRSS_Val.ScanType.KLPRSS_Val[0] === ScanTypeEnum.AllObjects &&
        data.ScanSettings.KLPRSS_Val.ScanSfxArchived.KLPRSS_Val[0] === true &&
        data.ScanSettings.KLPRSS_Val.ScanPacked.KLPRSS_Val[0] === true &&
        data.ScanSettings.KLPRSS_Val.ScanOle.KLPRSS_Val[0] === true &&
        data.ScanSettings.KLPRSS_Val.UseTimeLimit.KLPRSS_Val[0] === true &&
        data.ScanSettings.KLPRSS_Val.TimeLimit.KLPRSS_Val[0] === 60 &&
        data.ScanSettings.KLPRSS_Val.UseExcludeThreats.KLPRSS_Val[0] === false &&
        data.ScanArchived.KLPRSS_Val[0] === true &&
        data.ScanPlainMail.KLPRSS_Val[0] === true &&
        data.InfectedAction.KLPRSS_Val[0].ActionType.KLPRSS_Val === WebActionEnum.BlockDownload &&
        data.UseAdvancedActions.KLPRSS_Val[0] === false &&
        data.UseSizeLimit.KLPRSS_Val[0] === true ) {
        return ProtectionLevel.Recommended;
    }
    else if( data.ScanSettings.KLPRSS_Val.ScanType.KLPRSS_Val[0] === ScanTypeEnum.AllObjects &&
        data.ScanSettings.KLPRSS_Val.ScanSfxArchived.KLPRSS_Val[0] === true &&
        data.ScanSettings.KLPRSS_Val.ScanPacked.KLPRSS_Val[0] === true &&
        data.ScanSettings.KLPRSS_Val.ScanOle.KLPRSS_Val[0] === true &&
        data.ScanSettings.KLPRSS_Val.UseTimeLimit.KLPRSS_Val[0] === true &&
        data.ScanSettings.KLPRSS_Val.TimeLimit.KLPRSS_Val[0] === 60 &&
        data.ScanSettings.KLPRSS_Val.UseExcludeThreats.KLPRSS_Val[0] === false &&
        data.ScanArchived.KLPRSS_Val[0] === true &&
        data.ScanPlainMail.KLPRSS_Val[0] === true &&
        data.InfectedAction.KLPRSS_Val[0].ActionType.KLPRSS_Val === WebActionEnum.BlockDownload &&
        data.UseAdvancedActions.KLPRSS_Val[0]===false &&
        data.UseSizeLimit.KLPRSS_Val[0]===true ) {
        return ProtectionLevel.HighSecurity;
    }
    else if (
        data.ScanSettings.KLPRSS_Val.ScanType.KLPRSS_Val[0] === ScanTypeEnum.ByExtension &&
        data.ScanSettings.KLPRSS_Val.ScanSfxArchived.KLPRSS_Val[0] === false &&
        data.ScanSettings.KLPRSS_Val.ScanPacked.KLPRSS_Val[0] === true &&
        data.ScanSettings.KLPRSS_Val.ScanOle.KLPRSS_Val[0] === false &&
        data.ScanSettings.KLPRSS_Val.UseTimeLimit.KLPRSS_Val[0] === true &&
        data.ScanSettings.KLPRSS_Val.TimeLimit.KLPRSS_Val[0] === 60 &&
        data.ScanSettings.KLPRSS_Val.UseExcludeThreats.KLPRSS_Val[0] === false &&
        data.ScanArchived.KLPRSS_Val[0] === false &&
        data.ScanPlainMail.KLPRSS_Val[0] === true &&
        data.InfectedAction.KLPRSS_Val[0].ActionType.KLPRSS_Val === WebActionEnum.BlockDownload &&
        data.UseAdvancedActions.KLPRSS_Val[0]===false &&
        data.UseSizeLimit.KLPRSS_Val[0]===true &&
        data.SizeLimit.KLPRSS_Val[0]===20971520) {
        return ProtectionLevel.HighSpeed;
    }
    return ProtectionLevel.Custom;
}

function ResetToTsLevel(data, level) {
    switch(level){
    case ProtectionLevel.HighSecurity:
        data.ScanSettings.KLPRSS_Val.ScanType.KLPRSS_Val[0] = ScanTypeEnum.AllObjects;
        data.ScanSettings.KLPRSS_Val.ScanSfxArchived.KLPRSS_Val[0] = true;
        data.ScanSettings.KLPRSS_Val.ScanPacked.KLPRSS_Val[0] = true;
        data.ScanSettings.KLPRSS_Val.ScanOle.KLPRSS_Val[0] = true;
        data.ScanSettings.KLPRSS_Val.UseTimeLimit.KLPRSS_Val[0] = true;
        data.ScanSettings.KLPRSS_Val.TimeLimit.KLPRSS_Val[0] = 60;
        data.ScanSettings.KLPRSS_Val.UseExcludeThreats.KLPRSS_Val[0] = false;
        data.ScanArchived.KLPRSS_Val[0] = true;
        data.ScanPlainMail.KLPRSS_Val[0] = false;
        data.InfectedAction.KLPRSS_Val[0].ActionType.KLPRSS_Val = WebActionEnum.BlockDownload;
        data.SuspiciousAction.KLPRSS_Val[0].ActionType.KLPRSS_Val = WebActionEnum.Quarantine;
        data.UseAdvancedActions.KLPRSS_Val[0] = false;
        data.UseSizeLimit.KLPRSS_Val[0] = true;
        break;
    case ProtectionLevel.Recommended:
        data.ScanSettings.KLPRSS_Val.ScanType.KLPRSS_Val[0] = ScanTypeEnum.AllObjects;
        data.ScanSettings.KLPRSS_Val.ScanSfxArchived.KLPRSS_Val[0] = true;
        data.ScanSettings.KLPRSS_Val.ScanPacked.KLPRSS_Val[0] = true;
        data.ScanSettings.KLPRSS_Val.ScanOle.KLPRSS_Val[0] = true;
        data.ScanSettings.KLPRSS_Val.UseTimeLimit.KLPRSS_Val[0] = true;
        data.ScanSettings.KLPRSS_Val.TimeLimit.KLPRSS_Val[0] = 60;
        data.ScanSettings.KLPRSS_Val.UseExcludeThreats.KLPRSS_Val[0] = false;
        data.ScanArchived.KLPRSS_Val[0] = true;
        data.ScanPlainMail.KLPRSS_Val[0] = true;
        data.InfectedAction.KLPRSS_Val[0].ActionType.KLPRSS_Val = WebActionEnum.BlockDownload;
        data.SuspiciousAction.KLPRSS_Val[0].ActionType.KLPRSS_Val = WebActionEnum.Quarantine;
        data.UseAdvancedActions.KLPRSS_Val[0] = false;
        data.UseSizeLimit.KLPRSS_Val[0] = true;
        break;
    case ProtectionLevel.HighSpeed:
        data.ScanSettings.KLPRSS_Val.ScanType.KLPRSS_Val[0] = ScanTypeEnum.ByExtension;
        data.ScanSettings.KLPRSS_Val.ScanSfxArchived.KLPRSS_Val[0] = false;
        data.ScanSettings.KLPRSS_Val.ScanPacked.KLPRSS_Val[0] = true;
        data.ScanSettings.KLPRSS_Val.ScanOle.KLPRSS_Val[0] = false;
        data.ScanSettings.KLPRSS_Val.UseTimeLimit.KLPRSS_Val[0] = true;
        data.ScanSettings.KLPRSS_Val.TimeLimit.KLPRSS_Val[0] = 60;
        data.ScanSettings.KLPRSS_Val.UseExcludeThreats.KLPRSS_Val[0] = false;
        data.ScanArchived.KLPRSS_Val[0] = false;
        data.ScanPlainMail.KLPRSS_Val[0] = true;
        data.InfectedAction.KLPRSS_Val[0].ActionType.KLPRSS_Val = WebActionEnum.BlockDownload;
        data.SuspiciousAction.KLPRSS_Val[0].ActionType.KLPRSS_Val = WebActionEnum.Quarantine;
        data.UseAdvancedActions.KLPRSS_Val[0] = false;
        data.UseSizeLimit.KLPRSS_Val[0] = true;
        data.SizeLimit.KLPRSS_Val[0] = 20971520;
        break;
    }
    return data
}

module.exports = {
    CheckTsLevel,
    ResetToTsLevel
}